
!# libxlsxwriter for Clarion
!# based on libxlsxwriter.dll 0.7.5
!# https://libxlsxwriter.github.io 
!# RaFaeL 13.12.2017

 MAP
  MODULE('WIN API')
    GetSysColor(SIGNED),ULONG,PASCAL
    WideCharToMultiByte(long,long,*CSTRING,long,*CSTRING,long,long,long),LONG,PASCAL,RAW,PROC
    MultiByteToWideChar(long,long,*CSTRING,long,*CSTRING,long),LONG,PASCAL,RAW,PROC
  END

  MODULE('xlsxwriter.clw')
    RGBColor(LONG color),LONG
    GetSystemColor(LONG Color),LONG
    ConvertCharSet(*cstring sIn,long in_,long out_)
  END
 END

COMPILE('***',_TPictureClassPresent_)
 include('tpicture.inc'),once
***

XLSX:BorderLeft          EQUATE(1)
XLSX:BorderTop           EQUATE(2)
XLSX:BorderRight         EQUATE(4)
XLSX:BorderBottom        EQUATE(8)

XLSX:ALIGN_NONE          EQUATE(0)
XLSX:ALIGN_LEFT          EQUATE(1)
XLSX:ALIGN_CENTER        EQUATE(2)
XLSX:ALIGN_RIGHT         EQUATE(3)
XLSX:ALIGN_FILL          EQUATE(4)
XLSX:ALIGN_JUSTIFY       EQUATE(5)
XLSX:ALIGN_CENTER_ACROSS EQUATE(6)
XLSX:ALIGN_DISTRIBUTED   EQUATE(7)

XLSX:ALIGN_VERTICAL_TOP         EQUATE(8)
XLSX:ALIGN_VERTICAL_BOTTOM      EQUATE(9)
XLSX:ALIGN_VERTICAL_CENTER      EQUATE(10)
XLSX:ALIGN_VERTICAL_JUSTIFY     EQUATE(11)
XLSX:ALIGN_VERTICAL_DISTRIBUTED EQUATE(12)

XLSX:HIDE_ALL_GRIDLINES     EQUATE(0)
XLSX:SHOW_SCREEN_GRIDLINES  EQUATE(1)
XLSX:SHOW_PRINT_GRIDLINES   EQUATE(2)
XLSX:SHOW_ALL_GRIDLINES     EQUATE(3)

datetime GROUP,TYPE
year       LONG
month      LONG
day        LONG
hour       LONG
min        LONG
sec        REAL
 END

imageoptions GROUP,TYPE
x_offset    LONG
y_offset    LONG
x_scale     REAL
y_scale     REAL
 END

FormatType GROUP,TYPE
BorderStyle LONG
BorderColor LONG
Color       LONG
FontName    CSTRING(101)
FontSize    REAL
FontColor   LONG
FontStyle   LONG
Align       BYTE
AlignV      BYTE
WrapText    BYTE
Picture     CSTRING(101)
 END

FormatQType Queue,TYPE
FormatG       GROUP(FormatType)
              END
Ref           LONG
            END

xlsxwriter                    CLASS, TYPE, MODULE('xlsxwriter.clw'), LINK('xlsxwriter.clw')
Workbook                        LONG
ActiveWorksheet                 LONG
Filename                        CSTRING(256)

ActiveFormat                    LONG

Format                          GROUP(FormatType)
                                END

FormatQ                         &FormatQType

COMPILE('***',_TPictureClassPresent_)
Picture                         &TPictureClass
***

Construct                       PROCEDURE
Destruct                        PROCEDURE
NewWorkbook                     PROCEDURE(STRING Filename_)
AddWorksheet                    PROCEDURE(STRING Sheetname_),LONG
CloseWorkbook                   PROCEDURE(),LONG

WriteNumber                     PROCEDURE(LONG row_,LONG col_,REAL number_),LONG
WriteBoolean                    PROCEDURE(LONG row_,LONG col_,SHORT value_),LONG
WriteString                     PROCEDURE(LONG row_,LONG col_,STRING string_),LONG
WriteUrl                        PROCEDURE(LONG row_,LONG col_,STRING url_),LONG
WriteBlank                      PROCEDURE(LONG row_,LONG col_),LONG
WriteDateTime                   PROCEDURE(LONG row_,LONG col_,LONG date_,LONG Time_),LONG
WriteFormula                    PROCEDURE(LONG row_,LONG col_,STRING formula_,<REAL result>),LONG
Merge                           PROCEDURE(LONG first_row_,LONG first_col_,LONG last_row_,LONG last_col_),LONG
SetColumn                       PROCEDURE(LONG first_col_,LONG last_col_,REAL width_),LONG
SetRow                          PROCEDURE(LONG row_,REAL height_),LONG
ClearFormat                     PROCEDURE()
SetFormat                       PROCEDURE()
Gridlines                       PROCEDURE(BYTE option_)
FreezePanes                     PROCEDURE(LONG row_,LONG col_)
InsertImage                     PROCEDURE(LONG row_,LONG col_,STRING filename_,<*IMAGEOPTIONS options_>),LONG
StrError                        PROCEDURE(LONG error_num),STRING

                              END