!ABCIncludeFile(TPICT)
!------------------------------------------------------------------------------------------------------------
! Library Name ....  TPicture
! Description .....  Manage Clarion pictures to obtain screen masks, excel picture masks, etc...
! Version .........  1.1
! Copyright  2005-2009 by Edgard L. Riba (Taboga Software - www.tabogasoftware.com)
! All rights reserved
!------------------------------------------------------------------------------------------------------------

OMIT('_EndOfInclude_',_TPictureClassPresent_)
_TPictureClassPresent_ EQUATE(1)


!--- TFieldCollection CLASS ---------------------------------------------------------------------------------
TPictureClass  CLASS,TYPE,MODULE('TPicture.CLW'),LINK('TPicture.CLW',_TPictLinkMode_),DLL(_TPictDllMode_)
picture                 CSTRING(101)            !@D6
screenMask              CSTRING(256)            !<#/##/####
screenMaskLen           SHORT                   !8  => LEN(SELF.screenMask)
ExcelMask               CSTRING(101)            !Excel compatible picture...
pictureType             STRING(1)               !Contains the most basic picture type:  N,S,D,T,K,P    
!
Inited                  BYTE
!
!Number symbol information
significantDigits       BYTE                    !Significant digits (ie. "size")
decimalDigits           BYTE                    !Decimal digits...
currencySymbol          CSTRING(21)             !
currencyPos             CSTRING(11)             !LEADING|TRAILING
decimalSeparator        STRING(1)
groupCharacter          STRING(1)               !
negativeSign            CSTRING(11)             !LEADING|TRAILING|BRACKETS
allowBlank              BYTE
leadingCharacter        CSTRING(11)             !CLIP|ZERO|SPACE|ASTERISK
strictDeformat          BYTE                    !Should we be strict on deformat errors? Default = TRUE
!
!---Init/Kill
CONSTRUCT               PROCEDURE
DESTRUCT                PROCEDURE
!
!---Public interface...
TakePicture             PROCEDURE(STRING pPicture),LONG,PROC
DeformatNumber          PROCEDURE(STRING pValue),REAL
!
!
!
            END
_EndOfInclude_